IONICE=ionice
root_name=$1
files=$2
size=$(($3 * 1024))
weights=$4

max_w=`echo ${weights} | awk "{print \\$1}"`

# mapping: 
# w = max (1, (8 - ioprio - 1) * 2)
# ioprio = 8 - 1 - int(w / 2) 
# ioprio == 0 <=> w == 14
# ioprio == 1 <=> w == 12
# ioprio == 2 <=> w == 10
# ioprio == 3 <=> w == 8
# ioprio == 4 <=> w == 6
# ioprio == 5 <=> w == 4
# ioprio == 6 <=> w == 2
# ioprio == 7 <=> w == 1

function read_file
{
	root_name=$1
	ioprio=$2
	f=$3
	size=$4
	w=$5
	idx=$6

    	echo "$IONICE -n $ioprio dd if=$f of=/dev/null bs=1K count=$((($size * $w) / $max_w )) 2>&1 | tee $root_name$idx &"
    	$IONICE -n $ioprio dd if=$f of=/dev/null bs=1K count=$((($size * $w) / $max_w )) 2>&1 | tee "$root_name$idx" 
}

idx=0
for f in $files ; do
    w=`echo ${weights} | awk "{print $"$(($idx+1))"}"`
    ioprio=$((8 - 1 - ($w/2)))
    read_file "$root_name" $ioprio $f $size $w $idx &
    idx=$(($idx+1)) ;
done ; 
echo Before wait
wait

